prologin/archives/urls.py
from django.urls import path
import archives.views

app_name = 'archives'

urlpatterns = [
    path('', archives.views.Index.as_view(), name='index'),
    path('<int:year>/<type>/report', archives.views.Report.as_view(), name='report'),
    path('<int:year>/final/scoreboard', archives.views.FinalScoreboard.as_view(), kwargs={'type': 'final'}, name='finale-scoreboard'),
]

prologin/problems/urls.py
from django.urls import path
import problems.views

app_name = 'problems'

urlpatterns = [
    path('<int:year>/<type>', problems.views.Challenge.as_view(), name='challenge'),
    path('<int:year>/<type>/scoreboard', problems.views.ChallengeScoreboard.as_view(), name='challenge-scoreboard'),

    path('<int:year>/<type>/<problem>', problems.views.Problem.as_view(), name='problem'),
    path('<int:year>/<type>/<problem>/lang-template', problems.views.AjaxLanguageTemplate.as_view(), name='ajax-language-template'),
    path('<int:year>/<type>/<problem>/<int:submission>', problems.views.SubmissionCode.as_view(), name='submission'),

    path('submission-corrected/<int:submission>', problems.views.AjaxSubmissionCorrected.as_view(), name='ajax-submission-corrected'),
    path('submission-recorrect/<int:submission>', problems.views.RecorrectView.as_view(), name='submission-recorrect'),

    path('manual', problems.views.ManualView.as_view(), name='manual'),
    path('search', problems.views.SearchProblems.as_view(), name='search'),
    path('', problems.views.Index.as_view(), name='index'),
]

prologin/qcm/urls.py
from django.urls import path

import qcm.views

app_name = 'qcm'

urlpatterns = [
    path('', qcm.views.DisplayQCMView.as_view(), name='display'),
]

prologin/archives/models.py
import logging
import os
import redis, redis.exceptions
from django.conf import settings
from django.core.exceptions import ObjectDoesNotExist
from django.utils.safestring import mark_safe

import contest.models
import problems.models
import qcm.models
from archives.thirdparty.flickr import Flickr
from archives.thirdparty.vimeo import Vimeo
from prologin.utils import lazy_attr, open_try_hard
from prologin.utils.scoring import Scoreboard

logger = logging.getLogger('prologin.archives')


class BaseArchive:
    """
    Abstract class for {Qualification,Semifinal,Final}Archive.
    """
    dir_name = None
    event_type = None

    def __init__(self, archive):
        self.archive = archive

    def file_path(self, *tail) -> str:
        return self.archive.file_path(self.dir_name, *tail)

    def file_url(self, *tail) -> str:
        return os.path.join(settings.ARCHIVES_REPOSITORY_STATIC_PREFIX, self.archive.file_url(self.dir_name, *tail))

    @classmethod
    def file_url_or_none(cls, *tail) -> str:
        def func(self):
            path = self.file_path(*tail)
            if os.path.exists(path):
                return self.file_url(*tail)
            return None

        return func

    def populated(self):
        raise NotImplementedError("BaseArchive subclasses has to implement populated()")

    def __repr__(self):
        return "<{} for {}{}>".format(self.__class__.__name__,
                                      self.archive.year,
                                      '' if self.populated() else ' (empty)')


class WithChallengeMixin:
    """
    Mixin for archive types that have a problems.Challenge (qualification, semifinal).
    """
    event_type = None

    @property
    def challenge(self) -> problems.models.Challenge:
        try:
            challenge = problems.models.Challenge.by_year_and_event_type(self.archive.year, self.event_type)
            if hasattr(self.archive, 'user') and not self.archive.user.has_perm('problems.view_challenge', challenge):
                return None
            return challenge
        except ObjectDoesNotExist:
            return None


class WithContentMixin:
    """
    Mixin for archive types that have a content (semifinal, final).
    """

    def _get_content(self):
        def callback(obj):
            # TODO: parse the weird shit format
            return mark_safe(obj.read())

        try:
            return open_try_hard(callback, self.file_path('content.html'))
        except (ValueError, FileNotFoundError):
            return None

    content = lazy_attr('_content_', _get_content)


class QualificationArchive(WithChallengeMixin, BaseArchive):
    """
    Qualification archive. May have:
        - a challenge
        - a PDF statement
        - a PDF correction
        - a PDF challenge
    """
    dir_name = 'questionnaire'
    event_type = contest.models.Event.Type.qualification

    pdf_statement = lazy_attr('_pdf_statement_', BaseArchive.file_url_or_none('questionnaire.pdf'))
    pdf_correction = lazy_attr('_pdf_correction_', BaseArchive.file_url_or_none('correction.pdf'))
    pdf_challenges = lazy_attr('_pdf_challenges_', BaseArchive.file_url_or_none('challenges.pdf'))

    @property
    def quiz(self) -> qcm.models.Qcm:
        return self.archive.qcm

    def populated(self):
        return any((self.pdf_statement, self.pdf_correction, self.pdf_challenges, self.quiz, self.challenge))


class SemifinalArchive(WithContentMixin, WithChallengeMixin, BaseArchive):
    """
    Semifinal archive. May have:
        - a challenge
        - a content
    """
    dir_name = 'demi-finales'
    event_type = contest.models.Event.Type.semifinal

    def populated(self):
        return any((self.content, self.challenge))


class FinalArchive(WithContentMixin, BaseArchive):
    """
    Final archive. May have:
        - a content
        - a scoreboard
        - a flickr photo list
    """
    dir_name = 'finale'

    def _get_scoreboard(self):
        def reader(file):
            return file.readlines()

        def scoreboard_gen():
            lines = open_try_hard(reader, self.file_path('HallOfFame'))
            # pseudo_score so that decorate_with_rank can compute the rank with ties
            pseudo_score = 0
            for line in lines:
                line = line.strip()
                if not line:
                    continue
                if line.startswith('#'):
                    continue
                if line.lower().startswith('[tie]'):
                    # don't change the score when there is a tie
                    _, line = line.split('[tie]', 1)
                    line = line.strip()
                else:
                    pseudo_score -= 1
                name, *extra = line.split('(', 1)
                particle = name.split()[0]
                if particle.endswith('.'):
                    name = '{} {}'.format(particle.capitalize().strip(), name.split('.', 1)[1].strip())
                extra = ' '.join(p.strip().strip('()').strip() for p in extra)
                yield {'name': name.strip().title(), 'extra': extra, 'score': pseudo_score}

        try:
            return Scoreboard(scoreboard_gen())
        except FileNotFoundError:
            return None

    scoreboard = lazy_attr('_scoreboard_', _get_scoreboard)

    def populated(self):
        return any((self.content, self.scoreboard))


def subtype_factory(prop_name, cls):
    assert issubclass(cls, BaseArchive)

    def builder(self):
        return cls(self)

    return lazy_attr(prop_name, builder)


def get_poster_factory(size):
    name = 'poster.{}.jpg'.format(size)

    def getter(self):
        path = self.file_path(name)
        if os.path.exists(path):
            return os.path.join(settings.ARCHIVES_REPOSITORY_STATIC_PREFIX, self.file_url(name))
        return None

    return lazy_attr('_poster_{}_'.format(size), getter)


class Archive:
    """
    Root archive class for a given year.

    Use Archive.all_archives() to list all archives (result is sortable).
    Use Archive.by_year(year) to retrieve a specific year archive.

    Each Archive instance may have:
        - a full-size poster URL (.poster_full)
        - a thumbnail-size poster URL (.poster_thumb)

    Each Archive instance has the following attributes to access the respective event-archive instance:
        - qualification
        - semifinal
        - final
    """

    @classmethod
    def _qcm_queryset(cls):
        return (qcm.models.Qcm.objects
                .filter(event__type=contest.models.Event.Type.qualification.value))

    @classmethod
    def all_archives(cls):
        qcm_by_year = {qcm.event.edition.year: qcm for qcm in cls._qcm_queryset()}

        def explore():
            for year_dir in os.listdir(settings.ARCHIVES_REPOSITORY_PATH):
                if year_dir.isnumeric():
                    year = int(year_dir)
                    yield Archive(year, qcm_by_year.get(year))

        return explore()

    @classmethod
    def by_year(cls, year: int):
        qcm_obj = cls._qcm_queryset().filter(event__edition__year=year).first()
        return Archive(year, qcm_obj)

    def __init__(self, year: int, qcm_obj: qcm.models.Qcm):
        self.year = year
        self.qcm = qcm_obj

        if not os.path.exists(self.file_path()):
            raise ObjectDoesNotExist("Archive for year {} does not exist".format(year))

        self.photo_collection_url = None
        self.photo_cover_url = None
        self.photo_count = 0
        self.video_id = None
        self.video_picture_id = None
        try:
            self._populate_redis_attributes()
        except redis.exceptions.RedisError:
            pass

    def _populate_redis_attributes(self):
        decode = lambda d: d if d is None else d.decode()
        store = redis.StrictRedis(**settings.PROLOGIN_UTILITY_REDIS_STORE)
        pipe = store.pipeline()
        pipe.get(self.photo_collection_url_key)
        pipe.get(self.photo_cover_url_key)
        pipe.get(self.photo_count_key)
        pipe.get(self.video_id_key)
        pipe.get(self.video_picture_id_key)
        (self.photo_collection_url, cover_url, photo_count, self.video_id, self.video_picture_id,
        ) = map(decode, pipe.execute())
        if cover_url:
            # format with size 's' (small square)
            self.photo_cover_url = Flickr.photo_url_format(cover_url, 's')
        if photo_count:
            self.photo_count = int(photo_count)

    def file_path(self, *tail) -> str:
        return os.path.abspath(os.path.join(settings.ARCHIVES_REPOSITORY_PATH, self.file_url(*tail)))

    def file_url(self, *tail) -> str:
        return os.path.join(str(self.year), *tail)

    def _redis_key(self, suffix):
        return settings.ARCHIVES_REDIS_KEY.format(year=self.year, suffix=suffix)

    @property
    def photo_count_key(self):
        return self._redis_key('photos.count')

    @property
    def photo_collection_url_key(self):
        return self._redis_key('photos.url')

    @property
    def photo_cover_url_key(self):
        return self._redis_key('photos.cover.url')

    @property
    def video_id_key(self):
        return self._redis_key('video.id')

    @property
    def video_picture_id_key(self):
        return self._redis_key('video.picture.id')

    @property
    def video_embed_code(self):
        if not self.video_id:
            return
        return Vimeo.video_embed_code(self.video_id, width="100%", height=300)

    @property
    def video_cover_url(self):
        return Vimeo.video_cover_url(self.video_picture_id, size=48)

    @property
    def video_url(self):
        if not self.video_id:
            return
        return Vimeo.video_url(self.video_id)

    qualification = subtype_factory('_qualification_', QualificationArchive)
    semifinal = subtype_factory('_semifinal_', SemifinalArchive)
    final = subtype_factory('_final_', FinalArchive)

    poster_full = get_poster_factory('full')

prologin/archives/views.py
from django.core.exceptions import ObjectDoesNotExist
from django.http import Http404
from django.views.generic import TemplateView

import archives.models
from contest.models import Event


class Index(TemplateView):
    template_name = 'archives/index.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['archives'] = sorted(archives.models.Archive.all_archives(),
                                     reverse=True)
        for archive in context['archives']:
            archive.user = self.request.user
        return context


class SingleArchiveMixin:
    year_field = 'year'
    type_field = 'type'

    def get_archive(self) -> (archives.models.Archive, Event.Type):
        try:
            year = int(self.kwargs[self.year_field])
            event_type = Event.Type[self.kwargs[self.type_field]]
            return archives.models.Archive.by_year(year), event_type
        except (ObjectDoesNotExist, KeyError, ValueError):
            raise Http404()

    def get_context_data(self, **kwargs):
        archive, event_type = self.get_archive()
        context = {}
        context.update(kwargs)
        context['archive'] = archive
        context['event_type'] = event_type
        return super().get_context_data(**context)


class Report(SingleArchiveMixin, TemplateView):
    template_name = 'archives/report.html'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        attr = ('semifinal' if context['event_type'] is Event.Type.semifinal
                else 'final')
        context['content'] = getattr(context['archive'], attr).content
        if not context['content']:
            raise Http404()
        return context


class FinalScoreboard(SingleArchiveMixin, TemplateView):
    template_name = 'archives/finale-scoreboard.html'

    def get(self, request, *args, **kwargs):
        archive, event_type = self.get_archive()
        if not archive.final.scoreboard:
            raise Http404()
        return super().get(request, *args, **kwargs)

prologin/archives/templates/archives/finale-scoreboard.html
{% extends "prologin/base.html" %}
{% load i18n staticfiles %}
{% load django_bootstrap_breadcrumbs utils %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb_for "archives:index" %}{% trans "Archives" %}{% endbreadcrumb_for %}
  {% breadcrumb archive.year '' %}
  {% breadcrumb_for "archives:finale-scoreboard" archive.year %}{% trans "Final scoreboard" %}{% endbreadcrumb_for %}
{% endblock breadcrumbs %}

{% block extra_head %}
  <link href="{% static 'css/archives.css' %}" type="text/css" rel="stylesheet">
{% endblock %}

{% block title %}{% blocktrans with year=archive.year %}Final scoreboard for Prologin {{ year }} final{% endblocktrans %}{% endblock %}

{% block content %}
  <h1>{% blocktrans with year=archive.year %}Final scoreboard for Prologin {{ year }} final{% endblocktrans %}</h1>
  {% with scoreboard=archive.final.scoreboard %}
    {% include "archives/inline-scoreboard.html" %}
  {% endwith %}
{% endblock %}

prologin/archives/templates/archives/index.html
{% extends "prologin/base.html" %}
{% load i18n staticfiles %}
{% load django_bootstrap_breadcrumbs utils %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb_for "archives:index" %}{% trans "Archives" %}{% endbreadcrumb_for %}
{% endblock breadcrumbs %}

{% block extra_head %}
  <link href="{% static 'css/archives.css' %}" type="text/css" rel="stylesheet">
{% endblock %}

{% block title %}{% trans "Archives" %}{% endblock %}

{% block content %}

  <h1>{% trans "Archives" %}</h1>
  <p>{% blocktrans %}Looking for Prologin's last year poster? 1996 final's statement? 2003 quiz?
    You can find all the documents and photo albums from past Prologin editions in these pages.{% endblocktrans %}</p>

  <ul class="pager align-left">{% spaceless %}
    {% for archive in archives %}<li><a href="#prologin-{{ archive.year }}">{{ archive.year }}</a></li>{% endfor %}
  {% endspaceless %}</ul>

  <div class="row archive-container">
    {% for archive in archives %}
      <div class="col-md-4 col-sm-6 col-xs-12 archive" id="prologin-{{ archive.year }}">
        <div class="panel panel-default archive-item">
          <div class="panel-heading" {% if archive.poster_thumb %}style="background-image: url({% static archive.poster_thumb %});"{% endif %}>
            <h2>{% blocktrans with year=archive.year %}Prologin {{ year }}{% endblocktrans %}</h2>
            {% if archive.poster_thumb or archive.poster_full %}
              <div class="poster-button-cont"><a class="btn btn-primary btn-sm poster-button" href="{% if archive.poster_full %}{% static archive.poster_full %}{% else %}{% static archive.poster_thumb %}{% endif %}" target="_blank">
                <i class="fa fa-picture-o"></i> {% trans "Download poster" %}
              </a></div>
            {% else %}
              <div class="poster-button-cont"><button type="button" disabled="disabled" class="btn btn-default btn-sm poster-button">{% trans "Poster not available" %}</button></div>
            {% endif %}
          </div>
          <div class="panel-body archive-body">
            <h4>{% trans "Qualification" %}</h4>
            {% if archive.qualification.populated %}
              <ul class="nav">
              {% if archive.qualification.quiz %}
                <li><a href="{% url 'qcm:display' archive.year %}"><i class="fa fa-fw fa-th-list"></i> {% blocktrans count archive.qualification.quiz.question_count as count %}{{ count }}-question quiz{% plural %}{{ count }}-question quiz{% endblocktrans %}</a></li>
              {% endif %}
              {% if archive.qualification.challenge %}
                <li><a href="{% url 'problems:challenge' archive.qualification.challenge.year archive.qualification.challenge.event_type.name %}"><i class="fa fa-fw fa-pencil"></i> {% blocktrans count archive.qualification.challenge.problems|length as count %}{{ count }} problem{% plural %}{{ count }} problems{% endblocktrans %}</a></li>
              {% endif %}
              {% if archive.qualification.pdf_statement %}
                <li><a href="{% static archive.qualification.pdf_statement %}"><i class="fa fa-fw fa-file-o"></i> {% trans "Test statement (PDF)" %}</a></li>
              {% endif %}
              {% if archive.qualification.pdf_correction %}
                <li><a href="{% static archive.qualification.pdf_correction %}"><i class="fa fa-fw fa-file-text-o"></i> {% trans "Test correction (PDF)" %}</a></li>
              {% endif %}
              {% if archive.qualification.pdf_challenges %}
                <li><a href="{% static archive.qualification.pdf_challenges %}"><i class="fa fa-fw fa-file-text-o"></i> {% trans "Test Challenge correction (PDF)" %}</a></li>
              {% endif %}
              </ul>
            {% else %}
              <p class="archive-empty"><em>{% trans "Sorry, no resource available." %}</em></p>
            {% endif %}
              <h4>{% trans "Regional events" %}</h4>
            {% if archive.semifinal.populated %}
              <ul class="nav">
              {% if archive.semifinal.content %}
                <li><a href="{% url 'archives:report' archive.year 'semifinal' %}"><i class="fa fa-fw fa-bullhorn"></i> {% trans "Regional events report" %}</a></li>
              {% endif %}
              {% if archive.semifinal.challenge %}
                <li><a href="{% url 'problems:challenge' archive.semifinal.challenge.year archive.semifinal.challenge.event_type.name %}"><i class="fa fa-fw fa-pencil"></i> {% blocktrans count archive.semifinal.challenge.problems|length as count %}{{ count }} problem{% plural %}{{ count }} problems{% endblocktrans %}</a></li>
              {% endif %}
              </ul>
            {% else %}
              <p class="archive-empty"><em>{% trans "Sorry, no resource available." %}</em></p>
            {% endif %}
              <h4>{% trans "Final" %}</h4>
            {% if archive.final.populated %}
              <ul class="nav">
              {% if archive.final.content %}
                <li><a href="{% url 'archives:report' archive.year 'final' %}"><i class="fa fa-fw fa-bullhorn"></i> {% trans "Final report" %}</a></li>
              {% endif %}
              {% if archive.final.scoreboard %}
                <li><a href="{% url 'archives:finale-scoreboard' archive.year %}"><i class="fa fa-fw fa-trophy"></i> {% trans "Scoreboard" %}</a></li>
              {% endif %}
              </ul>
            {% else %}
              <p class="archive-empty"><em>{% trans "Sorry, no resource available." %}</em></p>
            {% endif %}
          </div>
          {% if archive.photo_collection_url or archive.video_id %}
          <div class="panel-footer archive-footer">
            {% if archive.video_id %}
              <div>
                <a href="{{ archive.video_url }}?autoplay=1">
                  <img src="{{ archive.video_cover_url }}" alt="{% trans "Video" %}" class="img-thumbnail archive-photo"/>
                  {% trans "Watch the video" %}</a>
              </div>
            {% endif %}
            {% if archive.photo_collection_url %}
            <div>
              <a href="{{ archive.photo_collection_url }}">
                {% if archive.photo_cover_url %}
                  <img src="{{ archive.photo_cover_url }}" alt="{% trans "Cover photo" %}" class="img-thumbnail archive-photo"/>
                {% endif %}
                {% blocktrans with count=archive.photo_count %}Browse the {{ count }} photos{% endblocktrans %}</a>
            </div>
            {% endif %}
          </div>
          {% endif %}
        </div>
      </div>
    {% endfor %}
  </div>

{% endblock %}

prologin/archives/templates/archives/inline-scoreboard.html
{% load i18n %}{% spaceless %}
<table class="table table-striped">
  <thead>
  <tr>
    <th></th>
    <th>{% trans "Rank" %}</th>
    <th>{% trans "Contestant" %}</th>
    <th></th>
  </tr>
  </thead>
  <tbody>
  {% for item in scoreboard %}
    <tr>
      <td class="text-center">
        <span class="challenge-trophy-{{ item.rank }}"><i class="fa fa-fw {% if item.rank <= 3 %}fa-trophy{% endif %}"></i></span>
      </td>
      <td style="white-space: nowrap;"><strong>{{ item.rank }}</strong>
        {% if item.ex_aequo %}
          <small> {% trans "(ex-aequo)" %}</small>{% endif %}</td>
      <td>{{ item.item.name }}</td>
      <td class="scoreboard-extra">{{ item.item.extra|default:'' }}</td>
    </tr>
  {% endfor %}
  </tbody>
</table>{% endspaceless %}

prologin/archives/templates/archives/report.html
{% extends "prologin/base.html" %}
{% load i18n staticfiles %}
{% load django_bootstrap_breadcrumbs markup utils %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb_for "archives:index" %}{% trans "Archives" %}{% endbreadcrumb_for %}
  {% breadcrumb_for "archives:report" archive.year event_type.name %}{% blocktrans with year=archive.year event=event_type|choiceenum_label %}Report for {{ event }} {{ year }}{% endblocktrans %}{% endbreadcrumb_for %}
{% endblock breadcrumbs %}

{% block extra_head %}
  <link href="{% static 'css/archives.css' %}" type="text/css" rel="stylesheet">
{% endblock %}

{% block title %}{% blocktrans with year=archive.year event=event_type|choiceenum_label %}Report for {{ event }} {{ year }}{% endblocktrans %}{% endblock %}

{% block content %}
  <h1>{% blocktrans with year=archive.year event=event_type|choiceenum_label %}Report for {{ event }} {{ year }}{% endblocktrans %}</h1>

  {{ content|archive_markdown:archive.final.scoreboard }}

{% endblock %}